﻿define('mods/vm.notifications',
    ['jquery', 'textprovider', 'presenter', 'messanger', 'grid', 'dataservice', 'usercontext'],
    function ($, tp, presenter, msgr, entitygrid, ds, uc) {

        var Modes = {
            Inbox: 'inbox',
            Sent : 'sent',
            Custom : 'custom'
        }

        var grid = new entitygrid.Grid();
        var _mode = ko.observable();
        function bind(mode, q)
        {
            _mode(mode);
            var query = ds.search('Notification');
            var uiDef = null;
            if (mode == Modes.Custom)
            {
                query = q;
                uiDef = "Notifications_All_Generic";
            }
            else if (mode == Modes.Inbox) {
                query.rules.relatedTo('User', 'Recipient', uc.currentUser().Id);
                uiDef = "Notifications_All_Inbox";
            }
            else if (mode == Modes.Sent) {
                query.rules.relatedTo('User', 'Sender', uc.currentUser().Id);
                uiDef = "Notifications_All_Sent";
            }   
            else
                throw Error("Unknown binding mode for vm.notifications");

            query.addProperty("Received");
            query.sort('Date', true);

            grid.bind(query, uiDef);
        }

        return { 
            bind: bind,
            Mode : _mode,
            template: 'Notifications_Grid',
            Items: grid.Items,
            Definition: grid.Definition,
            LoadedDef: grid.LoadedDef,
            Loaded: grid.Loaded,
            Sorting: grid.Sorting,
            Paging: grid.Paging,
            sort: grid.sort
        };
    });