﻿var NbuLib = NbuLib || {};
NbuLib.Core = {};

jQuery.fn.center = function (container) {

    if (!container) {
        this.css("position", "absolute");
        this.css("top", Math.max(0, (($(window).height() - this.outerHeight()) / 2) +
                                                    $(window).scrollTop()) + "px");
        this.css("left", Math.max(0, (($(window).width() - this.outerWidth()) / 2) +
                                                    $(window).scrollLeft()) + "px");
        return this;
    }
    else {
        this.css("position", "absolute");
        this.css("top", Math.max(0, (($(container).height() - this.outerHeight()) / 2) +
                                                    $(container).offset().top) + "px");
        this.css("left", Math.max(0, (($(container).width() - this.outerWidth()) / 2) +
                                                    $(container).offset().left) + "px");
        return this;
    }
}

NbuLib.extend = function (subClass, baseClass) {
    var inheritance = function() { };
    inheritance.prototype = baseClass.prototype;
    subClass.prototype = new inheritance();
    subClass.prototype.constructor = subClass;
    subClass.base = baseClass;
    //subClass.super = baseClass.prototype;
};

if (!Date.prototype.toISOString) {
    Date.prototype.toISOString = function () {
        function pad(n) { return n < 10 ? '0' + n : n }
        return this.getUTCFullYear() + '-'
            + pad(this.getUTCMonth() + 1) + '-'
            + pad(this.getUTCDate()) + 'T'
            + pad(this.getUTCHours()) + ':'
            + pad(this.getUTCMinutes()) + ':'
            + pad(this.getUTCSeconds()) + 'Z';
    };
}

NbuLib.Convert = {};
NbuLib.Convert.dateToString = function (d) {
    return d.toISOString();
}

NbuLib.Convert.stringToDate = function (s) {
    if (!s)
        return new Date();
    if (isNaN(new Date(s))) {
        var datePart = s.substring(0, s.indexOf('T'));
        var parts = datePart.split("-");
        var date = new Date(0);
        date.setYear(parseInt(parts[0]));
        date.setMonth(parseInt(parts[1]) - 1);
        if (parts[2][0] == '0') parts[2] = parts[2][1];
        date.setDate(parseInt(parts[2]));
        return date;
    }
    else
        return new Date(s);
}

NbuLib.Core.Page = function (name, template, vmClass, args) {
    this.Name = name;
    this.Templ = template;
    this.ViewModelCls = vmClass;
    this.ViewModelInst = null;
    this.ViewModelCtorArgs = args;
}

NbuLib.Core.Page.prototype.open = function (viewport) {
    $(viewport).attr("data-bind", "template : {name : '" + this.Templ + "'}");
    this.ViewModelInst = new this.ViewModelCls(this.ViewModelCtorArgs);
    //console.log(this.ViewModelInst);
    ko.applyBindings(this.ViewModelInst, viewport);
}

NbuLib.Core.Module = function (id, name, pages) {
    this.Id = id;
    this.Name = name;
    this.Pages = [];
    this._pagesHash = {};

    var self = this;

    if (pages) {
        $(pages).each(function () {
            self._pagesHash[this.Name] = this;
            self.Pages.push(this);
        });
    }
}

NbuLib.Core.Module.prototype.getPage = function (name) {
    return this._pagesHash[name];
}
